#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>

using namespace std;

int main()
{

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	short int n;
	cin >> n;
	int koorde[4][2]; //promeniti u n 2
	for (int i = 0; i < 4; i++)
	{
		cin >> koorde[i][0] >> koorde[i][1];
	}
	if (n < 4) {
		cout << 0;
	}
	else if (n == 4) {
		if (koorde[0][1] == koorde[1][1] == koorde[2][1]) {
			cout << 0;
		}
		else {
			cout << 1;
		}
	}
	else {
		cout << 3;
	}
	return 0;
}